<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, ref, type StyleValue, inject } from 'vue';
import { storeToRefs } from 'pinia';
import Post from '@/components/preview/shared/Post.vue';
import { usePreviewStore } from '@/stores/preview';
import { rgbToHsl } from '@/lib/utils';
import Line from '@/components/preview/freeform/Line.vue';
import LineGroup from '@/components/preview/freeform/LineGroup.vue';
import Comments from '@/components/preview/shared/CommentSidebar.vue';
import CopyModal from '@/components/preview/shared/CopyModal.vue';
import Button from '@/components/general/Button.vue';



const store = usePreviewStore();
const { style, data, lineArray, headline, subheadline, postIndex, columnIndex, isExport } = storeToRefs(store);

const configuration = inject<any>('configuration');
const textColorTitle = ref();

const textColorTitleCalculation = () => {
    if (style.value && style.value.backgroundImage) {
        let newCanvas = document.createElement('canvas');
        let context = newCanvas.getContext('2d');
        let myImg = new Image();
        let apiServer = configuration.apiServer;
        myImg.src = apiServer + style.value.backgroundImage;
        let rgb = { r: 0, g: 0, b: 0 };
        let count = 0;
        let i = -4;
        myImg.crossOrigin = "Anonymous";
        myImg.onload = function () {
            let height = myImg.naturalHeight || myImg.offsetHeight || myImg.height;
            let width = myImg.naturalWidth || myImg.offsetWidth || myImg.width;
            if (height > 100)
                height = 100;
            if (width > 200)
                width = 200;
            context?.drawImage(myImg, 0, 0);
            let data = context?.getImageData(0, 0, width, height).data;
            let length = data!.length;
            while ((i += 20 * 4) < length) {
                ++count;
                rgb.r = rgb.r + data![i];
                rgb.g = rgb.g + data![i + 1];
                rgb.b = rgb.b + data![i + 2];
            }
            rgb.r = Math.floor(rgb.r / count);
            rgb.g = Math.floor(rgb.g / count);
            rgb.b = Math.floor(rgb.b / count);

            var hsl = rgbToHsl(rgb.r, rgb.g, rgb.b);
            if (hsl && hsl[2] && hsl[2] <= 0.8)
                textColorTitle.value = { color: "white" };
            else
                textColorTitle.value = { color: "#666666" };
        }
    } else {
        textColorTitle.value = { color: "#666666" };
    }
};

textColorTitleCalculation();

const getContainerStyle = ref(computed(() => {
    let apiServer = configuration.apiServer;
    return {
        background: style.value != null && style.value.backgroundImage != null ?
            'url(' + apiServer + style.value.backgroundImage + ')' :
            (style.value != null && style.value.backgroundColor != null ? style.value.backgroundColor : 'white')
    } as StyleValue;

}));
const close = () => {
    postIndex.value = -1;
    columnIndex.value = -1;
}

const isCopyModalOpen = ref(false);
const showCopyModal = (value: boolean) => {
    isCopyModalOpen.value = value;
}

</script>
<template>
    <div :class="style?.font ? style.font : ''">
        <div>
            <div>
                <div id="container" class="w-[8000px] h-[8000px] max-h-[8000px] max-w-[8000px] relative"
                    :style="getContainerStyle">
                    <div class="select-none absolute top-3 left-3">
                        <span class="text-2xl w-full" :style="textColorTitle">{{ headline }}</span>
                        <div :style="textColorTitle">{{ subheadline }}</div>
                    </div>
                    <template v-for="post, elementIndex in data">
                        <Post :key="post.id" :id="post.id" :title="post.title" :body="post.body" :info="post.info"
                            :color="post.color" :shape="post.shape" :commentsCount="post.comments.length"
                            :postIndex="elementIndex"
                            :style="{ top: post.styleObject.top + 'px', left: post.styleObject.left + 'px', width: post.width ? post.width + 'px' : '150px',zIndex: 100, position:'absolute' }"
                            v-if="post.authorized"/>
                    </template>
                    <!--<Line :key="line.start + line.end + line.line_text" :line="line" v-for="line in lineArray" />-->
                    <LineGroup />
                </div>
            </div>
            <Comments v-if="postIndex >= 0" @close="close" />
        </div>
        <div v-if="!isExport">
            <div class="inline fixed top-4 right-4 z-[999] w-fit">
                <Tooltip :tooltip="$t('adminMenu.copy.label')">
                    <Button variant="white" @click="showCopyModal(true)">
                        <i class="ri-file-copy-line"></i>
                    </Button>
                </Tooltip>
                <CopyModal v-if="isCopyModalOpen" @close="showCopyModal(false)" />
            </div>
        </div>
    </div>
</template>